package com.sun.corba.se.impl.transport;

import com.sun.corba.se.impl.encoding.CDROutputObject;
import sun.corba.OutputStreamFactory;
import com.sun.corba.se.spi.protocol.CorbaMessageMediator;
import com.sun.corba.se.pept.encoding.OutputObject;
import com.sun.corba.se.impl.protocol.CorbaMessageMediatorImpl;
import com.sun.corba.se.spi.ior.iiop.GIOPVersion;
import com.sun.corba.se.pept.protocol.MessageMediator;
import com.sun.corba.se.pept.transport.ContactInfo;
import com.sun.corba.se.pept.broker.Broker;
import com.sun.corba.se.pept.transport.Connection;
import com.sun.corba.se.impl.protocol.SharedCDRClientRequestDispatcherImpl;
import com.sun.corba.se.pept.protocol.ClientRequestDispatcher;
import com.sun.corba.se.spi.ior.IOR;
import com.sun.corba.se.spi.transport.CorbaContactInfoList;
import com.sun.corba.se.spi.orb.ORB;
import com.sun.corba.se.impl.logging.ORBUtilSystemException;

public class SharedCDRContactInfoImpl extends CorbaContactInfoBase
{
    private static int requestId;
    protected ORBUtilSystemException wrapper;
    
    public SharedCDRContactInfoImpl(ORB orb, CorbaContactInfoList contactInfoList, IOR effectiveTargetIOR, short addressingDisposition) {
        this.orb = orb;
        this.contactInfoList = contactInfoList;
        this.effectiveTargetIOR = effectiveTargetIOR;
        this.addressingDisposition = addressingDisposition;
    }
    
    @Override
    public ClientRequestDispatcher getClientRequestDispatcher() {
        return new SharedCDRClientRequestDispatcherImpl();
    }
    
    public boolean isConnectionBased() {
        return false;
    }
    
    public boolean shouldCacheConnection() {
        return false;
    }
    
    public String getConnectionCacheType() {
        throw this.getWrapper().methodShouldNotBeCalled();
    }
    
    public Connection createConnection() {
        throw this.getWrapper().methodShouldNotBeCalled();
    }
    
    @Override
    public MessageMediator createMessageMediator(Broker broker, ContactInfo contactInfo, Connection connection, String s, boolean b) {
        if (connection != null) {
            throw new RuntimeException("connection is not null");
        }
        return new CorbaMessageMediatorImpl((ORB)broker, contactInfo, null, GIOPVersion.chooseRequestVersion((ORB)broker, this.effectiveTargetIOR), this.effectiveTargetIOR, SharedCDRContactInfoImpl.requestId++, this.getAddressingDisposition(), s, b);
    }
    
    @Override
    public OutputObject createOutputObject(MessageMediator messageMediator) {
        CorbaMessageMediator corbaMessageMediator = (CorbaMessageMediator)messageMediator;
        CDROutputObject cdrOutputObject = OutputStreamFactory.newCDROutputObject(this.orb, messageMediator, corbaMessageMediator.getRequestHeader(), corbaMessageMediator.getStreamFormatVersion(), 0);
        messageMediator.setOutputObject(cdrOutputObject);
        return cdrOutputObject;
    }
    
    public String getMonitoringName() {
        throw this.getWrapper().methodShouldNotBeCalled();
    }
    
    @Override
    public String toString() {
        return "SharedCDRContactInfoImpl[]";
    }
    
    protected ORBUtilSystemException getWrapper() {
        if (this.wrapper == null) {
            this.wrapper = ORBUtilSystemException.get(this.orb, "rpc.transport");
        }
        return this.wrapper;
    }
    
    static {
        SharedCDRContactInfoImpl.requestId = 0;
    }
}
